function out=prbs(vps,ips,mass,prbsurface,dv,const,sw_two)
%-------------------------------------------------
%   single plobe method program
%       PTjv[uf[^̓vO
%                               Data: 2010.02.18
%                           Modified: 2022.11.09
%-------------------------------------------------
%
% OUT=PRBS(VP[V],IP[A],MASS[u],SURFACE[m^3],DV[V])̓VO
% v[uVP-IPɑ΂AvY}p[^OUTvZ
% Ԃ܂BKX̎ނɉMASS̒l(D:2/He:4)
% уv[udɂ̕\ʐSURFACE̒l͂ĂB
% ȂVP,IPDVԊuŕꂽlvZɗp܂BDV
% ŝƂ͎s܂B
%
% OUT=PRBS(VP[V],IP[A],MASS[u],SURFACE[m^3],DV[V],CONST)́A
% f[^_CONSTƂɈړςs܂B
%
% vY}p[^OUT͍\̂ŏo͂܂B
%       OUT.laebl:  p[^
%       OUT.unit:   P
%       OUT.param:  p[^l
%
% o͂p[^͈ȉ̂悤ɂȂ܂B
%       Isat:   CIOad [mA]
%       Iesat:  dqOad [mA]
%       Te:     dqx [eV]
%   ne_Isat:    CIOad狁߂dqx [10^18m^-3]
%   ne_Iesat:   dqOad狁߂dqx [10^18m^-3]
%       Vf:     Vd [V]
%   Vs_fitting: tBbeBO狁߂ԓd [V]
%   Vs_theory:  _狁߂ԓd [V]

% Author: H. Tanaka (Nagoya University)

if nargin<=4, dv=[]; end
if nargin<=5, const=[]; end
if nargin<=6, sw_two=0; end

fh_lin=100;
fh_log=200;
fh_log2=300;

figure(fh_lin); 
plot(vps,ips,'.');
if isempty(dv)
    [vpsa,ind]=sort(vps); ipsa=ips(ind);
else
	vpsa=[]; ipsa=[];
	for i=ceil(min(vps)):dv:floor(max(vps))-dv
   %     lin0=i<=vps&vps<=i+1;
        lin0=i<=vps&vps<i+dv; %%% 20190621 modified
        vpsa=[vpsa;mean(vps(lin0))]; ipsa=[ipsa;mean(ips(lin0))];
    end
    linnan=isnan(vpsa);
    vpsa=vpsa(~linnan); ipsa=ipsa(~linnan);
end
if ~isempty(const)
 %   vpsa=moment(vpsa,const,1);
 %   ipsa=moment(ipsa,const,1);
    windowsize=const; %%% 20221109 modified (not to use moment.m)
    b=(1/windowsize)*ones(1,windowsize);
    a=1;
    vpsa=filter(b,a,vpsa); vpsa=vpsa(const:end);
    ipsa=filter(b,a,ipsa); ipsa=ipsa(const:end);
end
if ~(isempty(dv)&&isempty(const))
    hold on; plot(vpsa,ipsa,'r-'); hold off;
end
set(gca,'XLim',[min(vps)-10,max(vps)+10],'YLim',get(gca,'YLim'));
xlabel('V_p [V]'); ylabel('I_p [A]');

%%% CIOa̒ߎ
disp(['CIOä̗Iin_AI_̃v[ud́j']);
disp(['Select the ion saturation region']);
[ran0,tmp]=ginput(2); disp('clear!');
ran0=sort(ran0);
lin0=find(ran0(1)<vpsa&vpsa<ran0(2));
[p0,s]=polyfit(vpsa(lin0),ipsa(lin0),1);
iis_line=polyval(p0,vpsa);
%iis_line=repmat(mean(ipsa(lin0)),[length(vpsa),1]);    % ϒlZ
%figure(200);
%plot(vpsa,ipsa,'r-',vpsa,iis_line,'g--');
figure(fh_lin); hold on;
plot(vpsa,iis_line,'g--'); hold off;

%%% v[ud|dqd\
iesa=ipsa-iis_line;
figure(fh_log);
semilogy(vpsa,[abs(iesa),iesa]);
set(gca,'XLim',[min(vps)-10,max(vps)+10],'YLim',get(gca,'YLim'));
xlabel('V_p [V]'); ylabel('I_e [A]');

%%% dqOa̒ߎ
disp(['dqOä̗Iin_AI_̃v[ud́j']);
disp(['Select the electron saturation region']);
[ran0,tmp]=ginput(2); disp('clear!');
ran0=sort(ran0); 
%lin0=find(ran0(1)<vpsa&vpsa<ran0(2));
lin0=find(ran0(1)<vpsa&vpsa<ran0(2)&iesa>0); % mod: 20200908
[p1,s]=polyfit(vpsa(lin0),log10(iesa(lin0)),1);
iie_line=10.^polyval(p1,vpsa);
hold on; plot(vpsa,iie_line,'g--'); hold off;

%%% dqx͈͂̎w
disp('dqx]ł悤ɁA}K؂Ɋg債Ă');
disp('g傪IA"return"6͂EnterL[Ă');
disp(['After the magnification to estimate Te, type "return" and press Enter']); 
keyboard; disp('clear!');
disp(['dqxf̈Iin_AI_̃v[ud́j']);
disp(['Select the inclined electron current region']);
figure(fh_log);
[ran0,tmp]=ginput(2); disp('clear!');
ran0=sort(ran0); 
%lin0=find(ran0(1)<vpsa&vpsa<ran0(2));
lin0=find(ran0(1)<vpsa&vpsa<ran0(2)&iesa>0); % mod: 20200908
if 0    % wIɉ׏d
    [p3,fy]=fitting(vpsa,iesa,ran0,[min(iesa)*1e-3,max(iesa)*1e3],'EXP0',[],0);
    te_line=p3(1)*10.^(p3(2)/log(10)*vpsa);
    p2(1)=p3(2)/log(10); p2(2)=log10(p3(1));
else    % `ɉ׏d
    [p2,s]=polyfit(vpsa(lin0),log10(iesa(lin0)),1);
    te_line=10.^polyval(p2,vpsa);
end

hold on; plot(vpsa,te_line,'r--'); hold off;

%%% e萔̑
mp=1.6726231e-27;                                   % mass of proton
me=9.1093897e-31;                                   % mass of electron
e=1.60217733e-19;                                   % elementary electric charge
k=1.3806503e-23;                                    % Boltzmann constant

%%% vY}p[^̌vZ
te=1/p2(1)/log(10);                         % dqx
vse=-(p1(2)-p2(2))/(p1(1)-p2(1));   % ԓdʁi_ςj
iesat=10^(p2(1)*vse+p2(2));         % dqOadi_ςj
isat=-polyval(p0,vse);              % CIOad

fluxi=isat/(e*prbsurface);
vf=NaN; div=10;
while isnan(vf)
    vf=mean(vpsa(-isat/div<ipsa&ipsa<isat/div)); % Vd
    div=div-1;
end
nei=(exp(-0.5)*prbsurface*e*sqrt(e*te/(mass*mp)))^-1*isat;   % dqxiCIOadj
vsi=vf-1/2*log(2*pi*me/(mp*mass))*te+1/2*te;            % ԓdʁiVdʁ{V[X[dʁ{vV[Xdʁj
nee=(1/4*e*prbsurface*sqrt(8*e*te/pi/me))^-1*iesat;     % dqxidqOadj

cs=sqrt(te*e/(mp*mass));
fluxe=exp(-0.5)*nee*cs;

figure(fh_lin);
hold on; plot([1;1]*vse,get(gca,'YLim'),'k--'); hold off;
figure(fh_log);
hold on; plot([1;1]*vse,get(gca,'YLim'),'k--'); hold off;


%%%%%%%%%%%%%%%%%%%%%%%%%% OUTPUT %%%%%%%%%%%%%%%%%%%%%%%%%%
%%% R}hEBhE\
disp(['==================================================']);
disp(['Isat=' num2str(isat*1e3,3) ' [mA] / Iesat=' num2str(iesat*1e3,3) ' [mA]']);
disp(['Te=' num2str(te,3) ' [eV] / ne_Isat=' num2str(nei/1e18,3) ' [E18m-3] / ne_Iesat=' num2str(nee/1e18,3) ' [E18m-3]']);
disp(['Vf=' num2str(vf,3) ' [V] / Vs_fitting=' num2str(vse,3) ' [V] / Vs_theory=' num2str(vsi,3) ' [V]']);
disp(['flux(i)=' num2str(fluxi/1e22,3) ' [E22m-2s-1] / flux(e)=' num2str(fluxe/1e22,3) ' [E22m-2s-1]']);
disp(['==================================================']);

label={'Isat' 'Iesat' 'Te' 'ne_Isat' 'ne_Iesat' 'Vf' 'Vs_fitting' 'Vs_theory' 'flux(i)' 'flux(e)'};
unit={'[mA]' '[mA]' '[eV]' '[E18m-3]' '[E18m-3]' '[V]' '[V]' '[V]' '[E22m-2s-1]' '[E22m-2s-1]'};
param={isat*1e3,iesat*1e3,te,nei/1e18,nee/1e18,vf,vse,vsi,fluxi/1e22,fluxe/1e22};
out.label=label;
out.unit=unit;
out.param=param;

if sw_two==0, return
elseif sw_two==1 %%% 2dqxΉ
    %%% dq̃tBbeBO
    figure(fh_log);
    disp('dq̗̈Iin_AI_̃v[ud́j');
    disp(['Select the electron saturation region for high-temperature component']);
    [ran0,tmp]=ginput(2); disp('clear!');
    ran0=sort(ran0);
    %lin0=find(ran0(1)<vpsa&vpsa<ran0(2));
    lin0=find(ran0(1)<vpsa&vpsa<ran0(2)&iesa>0); % mod: 20200908
    [p3,s]=polyfit(vpsa(lin0),log10(iesa(lin0)),1);
    iieh_line=10.^polyval(p3,vpsa);
    hold on; plot(vpsa,iieh_line,'c--'); 
    plot([vse,vse],[min(iieh_line),max(iieh_line)],'k:',...
        [vf,vf],[min(iieh_line),max(iieh_line)],'k:'); hold off;
    teh=1/p3(1)/log(10);
    iesath=10^(p3(1)*vse+p3(2));
    neeh=(1/4*e*prbsurface*sqrt(8*e*teh/pi/me))^-1*iesath;     % dqxidqOadj

    %%% ᑬdq̃tBbeBO
    figure(fh_log2);
    semilogy(vpsa,[abs(iesa-iieh_line),(iesa-iieh_line)]);
    set(gca,'XLim',[min(vps)-10,max(vps)+10],'YLim',get(gca,'YLim'));
    xlabel('V_p [V]'); ylabel('I_e(low-T_e component) [A]');
    hold on; plot([vse,vse],[min(iieh_line),max(iieh_line)],'k:',...
        [vf,vf],[min(iieh_line),max(iieh_line)],'k:'); hold off;
    disp('dqx]ł悤ɁA}K؂Ɋg債Ă');
    disp('g傪IA"return"6͂EnterL[Ă');
    disp(['After the magnification to estimate Te, type "return" and press Enter']); 
    keyboard; disp('clear!');
    disp(['ᑬdq̓dqxf̈Iin_AI_̃v[ud́j']);
    disp(['Select the inclined electron current region for low-temperature component']);
    [ran0,tmp]=ginput(2); disp('clear!');
    ran0=sort(ran0); 
    %lin0=find(ran0(1)<vpsa&vpsa<ran0(2));
    lin0=find(ran0(1)<vpsa&vpsa<ran0(2)&iesa>0); % mod: 20200908
    [p4,s]=polyfit(vpsa(lin0),log10(iesa(lin0)-iieh_line(lin0)),1);
    iiel_line=10.^(polyval(p4,vpsa));
    hold on; plot(vpsa,iiel_line,'m--'); hold off;
    tel=1/p4(1)/log(10);
  %  iesatl=10^(p4(1)*vse+p4(2));
    iesatl=iesat-iesath; % mod: 20221004
    neel=(1/4*e*prbsurface*sqrt(8*e*tel/pi/me))^-1*iesatl;     % dqxidqOadj

    %%% R}hEBhE\
    disp(['==================================================']);
    disp(['Iesat(HIGH)=' num2str(iesath*1e3,3) ' [mA] / Iesat(LOW)=' num2str(iesatl*1e3,3) ' [mA]']);
    disp(['Te(HIGH)=' num2str(teh,3) ' [eV] / Te(LOW)=' num2str(tel,3) ' [eV]']);
    disp(['ne_Iesat(HIGH)=' num2str(neeh/1e18,3) ' [E18m-3] / ne_Iesat(LOW)=' num2str(neel/1e18,3) ' [E18m-3]']);
    disp(['==================================================']);

    label=[label {'Iesat(HIGH)' 'Iesat(LOW)' 'Te(HIGH)' 'Te(LOW)' 'ne_Iesat(HIGH)' 'ne_Iesat(LOW)'}];
    unit=[unit {'[mA]' '[mA]' '[eV]' '[eV}' '[E18m-3]' '[E18m-3]'}];
    param=[param {iesath*1e3,iesatl*1e3,teh,tel,neeh/1e18,neel/1e18}];
    out.label=label;
    out.unit=unit;
    out.param=param;
end

return

